Subject: bug#8001: closed (Re: bug#8001: cp (8.10) sparse handling fails on compressed btrfs (cp/fiemap-2))

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 23 Feb 2011 09:54:02 +0000

Your bug report

#8001: cp (8.10) sparse handling fails on compressed btrfs (cp/fiemap-2)

which was filed against the coreutils package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
8001: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=8001
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#8001: cp (8.10) sparse handling fails on compressed btrfs (cp/fiemap-2)
From: Pádraig Brady <[email-masked]>
To: Chris Mason <[email-masked]>, [email-masked]
Cc: Mike Frysinger <[email-masked]>, BTRFS MAILING LIST <[email-masked]>
Date: Wed, 23 Feb 2011 09:49:55 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

On 23/02/11 03:31, Chris Mason wrote:
> I've got a fix for this on the btrfs side in testing.  It is definitely
> a btrfs bug.

[resend]

Cool.
I'm closing this ticket, so.

Interesting I didn't notice this with kernel-2.6.38-0.rc4.git0.2.fc15.i686
(with a 1G loop back BTRFS on ext4)

I'd appreciate a link to the fix at some stage.
If we know what's going on exactly we might be
able to know how widespread the issue is and
whether we could work around it in `cp`.

cheers,
Pádraig.

Subject: cp (8.10) sparse handling fails on compressed btrfs (cp/fiemap-2)
From: Mike Frysinger <[email-masked]>
To: [email-masked]
Date: Mon, 7 Feb 2011 22:53:26 -0500
List-Id: <debbugs-submit.debbugs.gnu.org>

after upgrading from coreutils 8.9 to 8.10, the sparse handling in cp is 
silently breaking on btrfs filesystems with the compressed option enabled.  
using --sparse=never works fine, but "auto" or "always" tend to fail.  the 
cp/fiemap-2 test catches the issue nicely.

to reproduce (i'm using linux-2.6.37):
file=btrfs.img
mntp=/mnt/tmp/
dd if=/dev/zero of=$file bs=1M count=0 seek=1024
mkfs.btrfs $file 
mount -t btrfs -o compress $file $mntp
cd $mntp
tar xf ~/coreutils-8.10.tar.xz
cd coreutils-8.10/tests
./cp/fiemap-2

and this last test shows:
Filesystem    Type   1K-blocks      Used Available Use% Mounted on
/dev/loop0   btrfs     1048576     20420    377028   6% /mnt/tmp
0+0 records in
0+0 records out
0 bytes (0 B) copied, 2.7598e-05 s, 0.0 kB/s
k k2 differ: byte 1, line 1
255+0 records in
255+0 records out
261120 bytes (261 kB) copied, 0.00310926 s, 84.0 MB/s
-mike